#include <cstdio>
#include <algorithm>

using namespace std;

struct Card {
	char rank;
	char color;
	
	void operator=(const Card& c) {
		rank = c.rank;
		color = c.color;
	}
	
	void print() {
		printf("%c%c", rank, color);
	}
};

struct Player {
	Card cards[7];
	
	void print() {
		for (int i = 0; i < 7; ++i) {
			cards[i].print();
			printf(" ");
		}
		printf("\n");
	}
};

enum HandType {
	ONE_CARD, PAIR, TWO_PAIRS, THREE, STRAIGHT, FLUSH, FULL_HOUSE, POKER, ROYAL_FLUSH
};

int rankToInt(char r) {
	if (r >= '2' && r <= '9')
		return r - '0';
	switch (r) {
		case 'X': return 10;
		case 'J': return 11;
		case 'Q': return 12;
		case 'K': return 13;
		case 'A': return 14;
		default: return 0;
	}
}

bool cmp(const Card& a, const Card& b) {
	return rankToInt(a.rank) < rankToInt(b.rank);
}

int main() {
	int n;
	
	while (scanf("%d\n", &n) != EOF) {
		Card shared[5];
		scanf("%c%c %c%c %c%c %c%c %c%c\n", 
				&(shared[0].rank), &(shared[0].color),
				&(shared[1].rank), &(shared[1].color),
				&(shared[2].rank), &(shared[2].color),
				&(shared[3].rank), &(shared[3].color),
				&(shared[4].rank), &(shared[4].color));
				
		Player players[n];
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < 5; ++j)
				players[i].cards[j] = shared[j];
			scanf("%c%c %c%c\n",
					&(players[i].cards[5].rank), &(players[i].cards[6].color),
					&(players[i].cards[5].rank), &(players[i].cards[6].color));
			
			//shared[i].print();
			//sort(players[i].cards, players[i].cards + 7, cmp);
		}
		
		HandType hands[n];
		for (int i = 0; i < n; ++i) {
			players[i].print();
		}
	}
}
